#ifndef SPICETOOLS_LCDHANDLE_H
#define SPICETOOLS_LCDHANDLE_H

#include <vector>
#include <windows.h>
#include "util/logging.h"
#include "hooks/devicehook.h"

namespace games::shared {

    class LCDHandle : public CustomHandle {
    private:
        std::vector<uint8_t> read_buffer;

        void answer(std::string s);

    public:
        bool open(LPCWSTR lpFileName) override;

        int read(LPVOID lpBuffer, DWORD nNumberOfBytesToRead) override;

        int write(LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite) override;

        int device_io(DWORD dwIoControlCode, LPVOID lpInBuffer, DWORD nInBufferSize, LPVOID lpOutBuffer,
                      DWORD nOutBufferSize) override;

        bool close() override;
    };
}

#endif //SPICETOOLS_LCDHANDLE_H
